/*
   KAIST CS520 2000
   parser spec
   Kwangkeun Yi
*/
%{       
exception EmptyBinding         
val rec desugarLet =
  fn (nil, e) => raise EmptyBinding
   | (a::nil, e) => M.LET(a,e)
   | (a::r, e) => M.LET(a, desugarLet(r,e))
%}
  
%token AND OR IF THEN ELSE LET IN END FN FX READ WRITE RARROW EQUAL
%token PLUS MINUS STAR SLASH LANGLE RANGLE LP RP VAL EOF 
%token <int> NUM
%token <string> ID
%token <string> STRING

%right FN FX RARROW LET
%right WRITE
%nonassoc IF THEN ELSE
%left EQUAL
%left OR         
%left AND
%left LANGLE RANGLE         
%left PLUS MINUS
%left STAR SLASH         
%nonassoc NUM ID READ LP

%start program
%type <M.exp> program
%type <M.exp> expr
%type <M.decl> decl         
%type <M.decl list> decls         

%%
program: expr EOF   {$1}
     ;
expr: aexpr {$1}
    | expr aexpr {M.APP($1,$2)}
    | expr PLUS expr {M.BOP(M.ADD,$1,$3)}
    | expr MINUS expr {M.BOP(M.SUB,$1,$3)}
    | expr STAR expr {M.BOP(M.MUL,$1,$3)}
    | expr SLASH expr {M.BOP(M.DIV,$1,$3)}
    | expr LANGLE expr {M.BOP(M.LT,$1,$3)}
    | expr RANGLE expr {M.BOP(M.GT,$1,$3)}
    | expr EQUAL expr {M.BOP(M.EQ,$1,$3)}
    | expr AND expr {M.BOP(M.AND,$1,$3)}
    | expr OR expr {M.BOP(M.OR,$1,$3)}
    ;
aexpr: LP expr RP {$2}
    | NUM {M.INT($1)}
    | ID {M.VAR($1)}
    | LET decls IN expr END {desugarLet($2,$4)}
    | FN ID RARROW expr {M.FN($2,$4)}
    | FX ID expr {M.FX($2,$3)}
    | IF expr THEN expr ELSE expr {M.IF($2,$4,$6)}
    | READ {M.READ}
    | WRITE expr {M.WRITE ($2)}
    ;        
decls: decl {[$1]}
    | decls decl {$1 @ [$2]}
    ;    
decl: VAL ID EQUAL expr {($2, $4)}
    ;
%%
